/*
 * GToolKit - Objective-C interface to the GIMP Toolkit
 * Copyright (c) 1999  Elmar Ludwig - Universitaet Osnabrueck
 *
 * Generated automatically from gtkaccelgroup.h by gtkgen.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 */
#ifndef GTOOLKIT_GTKACCELGROUP_H
#define GTOOLKIT_GTKACCELGROUP_H

#include <GToolKit/GTK.h>
#include <gtk/gtkaccelgroup.h>

@interface GTKAccelGroup : GTK
+ accelGroup;
- init;
+ (GTKAccelGroup*) getDefault;
- (GTKAccelGroup*) ref;
- (void) unref;
- (gboolean) activate:(guint) accel_key accelMods:(GdkModifierType) accel_mods;
- (void) attach:(GTKObject *) object;
- (void) detach:(GTKObject *) object;
- (void) lock;
- (void) unlock;
- (GtkAccelEntry*) getEntry:(guint) accel_key accelMods:(GdkModifierType) accel_mods;
- (void) lockEntry:(guint) accel_key accelMods:(GdkModifierType) accel_mods;
- (void) unlockEntry:(guint) accel_key accelMods:(GdkModifierType) accel_mods;
- (void) add:(guint) accel_key accelMods:(GdkModifierType) accel_mods accelFlags:(GtkAccelFlags) accel_flags object:(GTKObject *) object accelSignal:(const NSString *) accel_signal;
- (void) remove:(guint) accel_key accelMods:(GdkModifierType) accel_mods object:(GTKObject *) object;
+ (void) handleAdd:(GTKObject *) object accelSignalId:(guint) accel_signal_id accelGroup:(GTKAccelGroup *) accel_group accelKey:(guint) accel_key accelMods:(GdkModifierType) accel_mods accelFlags:(GtkAccelFlags) accel_flags;
+ (void) handleRemove:(GTKObject *) object accelGroup:(GTKAccelGroup *) accel_group accelKey:(guint) accel_key accelMods:(GdkModifierType) accel_mods;
+ (guint) createAdd:(GtkType) class_type signalFlags:(GtkSignalRunType) signal_flags handlerOffset:(guint) handler_offset;
+ (guint) createRemove:(GtkType) class_type signalFlags:(GtkSignalRunType) signal_flags handlerOffset:(guint) handler_offset;
+ (GSList*) entriesFromObject:(GTKObject *) object;
@end

#endif
