/*
 * GToolKit - Objective-C interface to the GIMP Toolkit
 * Copyright (c) 1999  Elmar Ludwig - Universitaet Osnabrueck
 *
 * Generated automatically from gtkobject.h by gtkgen.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 */
#ifndef GTOOLKIT_GTKOBJECT_H
#define GTOOLKIT_GTKOBJECT_H

#include <GToolKit/GTK.h>
#include <gtk/gtkobject.h>

@interface GTKObject : GTK
+ (GtkType) getType;
+ (guint) classUserSignalNewv:(GtkObjectClass *) klass name:(const NSString *) name signalFlags:(GtkSignalRunType) signal_flags marshaller:(GtkSignalMarshaller) marshaller returnVal:(GtkType) return_val nparams:(guint) nparams params:(GtkType *) params;
+ objectvWithObjectType:(GtkType) object_type nArgs:(guint) n_args args:(GtkArg *) args;
- initvWithObjectType:(GtkType) object_type nArgs:(guint) n_args args:(GtkArg *) args;
- (void) defaultConstruct;
- (void) constructed;
- (void) sink;
- (void) ref;
- (void) unref;
- (void) weakref:(GtkDestroyNotify) notify data:(gpointer) data;
- (void) weakunref:(GtkDestroyNotify) notify data:(gpointer) data;
- (void) destroy;
- (void) getv:(guint) n_args args:(GtkArg *) args;
- (void) setv:(guint) n_args args:(GtkArg *) args;
+ (GtkArg*) queryArgs:(GtkType) class_type argFlags:(guint32 **) arg_flags nArgs:(guint *) n_args;
- (void) setData:(const NSString *) key data:(gpointer) data;
- (void) setDataFull:(const NSString *) key data:(gpointer) data destroy:(GtkDestroyNotify) destroy;
- (void) removeData:(const NSString *) key;
- (gpointer) getData:(const NSString *) key;
- (void) removeNoNotify:(const NSString *) key;
- (void) setUserData:(gpointer) data;
- (gpointer) getUserData;
+ (void) classAddSignals:(GtkObjectClass *) klass signals:(guint *) signals nsignals:(guint) nsignals;
+ (void) addArgType:(const NSString *) arg_name argType:(GtkType) arg_type argFlags:(guint) arg_flags argId:(guint) arg_id;
- (void) setDataById:(GQuark) data_id data:(gpointer) data;
- (void) setDataByIdFull:(GQuark) data_id data:(gpointer) data destroy:(GtkDestroyNotify) destroy;
- (gpointer) getDataById:(GQuark) data_id;
- (void) removeDataById:(GQuark) data_id;
- (void) removeNoNotifyById:(GQuark) key_id;
- (void) argSet:(GtkArg *) arg info:(GtkArgInfo *) info;
- (void) argGet:(GtkArg *) arg info:(GtkArgInfo *) info;
+ (NSString *) argsCollect:(GtkType) object_type argListP:(GSList **) arg_list_p infoListP:(GSList **) info_list_p firstArgName:(const NSString *) first_arg_name varArgs:(va_list) var_args;
+ (NSString *) argGetInfo:(GtkType) object_type argName:(const NSString *) arg_name infoP:(GtkArgInfo **) info_p;
@end

#endif
